<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc (11.0.1) on Sat Oct 05 11:12:57 CEST 2019 -->
<title>TfIdfAnalyzer (dblp.datatools 2019.08.0.0 API)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2019-10-05">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="TfIdfAnalyzer (dblp.datatools 2019.08.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">bous.philipp.dblp.datatools.featurescoring</a></div>
<h2 title="Class TfIdfAnalyzer" class="title">Class TfIdfAnalyzer</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>bous.philipp.dblp.datatools.featurescoring.TfIdfAnalyzer</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">TfIdfAnalyzer</span>
extends java.lang.Object</pre>
<div class="block">Class providing means to perform an analysis to calculate tf-idf-values for a set of terms/documents.
 Requires the user to indicate when the currently observed document changes.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">TfIdfAnalyzer</a></span>()</code></th>
<td class="colLast">
<div class="block">Standard-constructor that will initialize the first document's number to be 1 beside necessary initialization.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#finish()">finish</a></span>()</code></th>
<td class="colLast">
<div class="block">Should be called if all relevant terms for the analysis have been added.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getNumberOfoccurrencesOfTermInDocument(java.lang.String,int)">getNumberOfoccurrencesOfTermInDocument</a></span>&#8203;(java.lang.String&nbsp;term,
                                      int&nbsp;docNumber)</code></th>
<td class="colLast">
<div class="block">Returns the number of occurrences of a given term in a given document as known by this analysis meaning it
 is not useful before the analysis has been done.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.String,&#8203;java.util.Map&lt;java.lang.Integer,&#8203;java.lang.Double&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getTfIdfAsMap()">getTfIdfAsMap</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns information about tfidf in the form of a map.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#idf(java.lang.String)">idf</a></span>&#8203;(java.lang.String&nbsp;term)</code></th>
<td class="colLast">
<div class="block">Returns the inverse document frequency for a given term as calculated through:
 log_10(total number of documents/ number od documents containing this term).</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#nextDocument()">nextDocument</a></span>()</code></th>
<td class="colLast">
<div class="block">Has to be called to signal to the TfidfAnalyzer that the document switched to a new one.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#tf(java.lang.String,int)">tf</a></span>&#8203;(java.lang.String&nbsp;term,
  int&nbsp;docNumber)</code></th>
<td class="colLast">
<div class="block">Returns the term-frequency for a given term and document.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#tfidf(java.lang.String,int)">tfidf</a></span>&#8203;(java.lang.String&nbsp;term,
     int&nbsp;docNumber)</code></th>
<td class="colLast">
<div class="block">Returns the tf-idf-value of a given term for a given document.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.String,&#8203;java.lang.Double&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#tfIdfsForDocument(int)">tfIdfsForDocument</a></span>&#8203;(int&nbsp;docNumber)</code></th>
<td class="colLast">
<div class="block">Calculates tf-idfs for tokens in a document with the specified document number.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.String,&#8203;java.lang.Double&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#tfIdfsForDocument(int,java.lang.String%5B%5D)">tfIdfsForDocument</a></span>&#8203;(int&nbsp;documentNumber,
                 java.lang.String[]&nbsp;tokens)</code></th>
<td class="colLast">
<div class="block">Calculates tf-idfs for tokens in a document with the specified document number.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#updateForTerm(java.lang.String)">updateForTerm</a></span>&#8203;(java.lang.String&nbsp;term)</code></th>
<td class="colLast">
<div class="block">Updates the analysis with a sighting of the given term for the current document.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#updateForTerms(java.lang.String%5B%5D)">updateForTerms</a></span>&#8203;(java.lang.String[]&nbsp;terms)</code></th>
<td class="colLast">
<div class="block">Updates the analysis with sightings of the given terms for the current document.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#updateForTerms(java.util.List)">updateForTerms</a></span>&#8203;(java.util.List&lt;java.lang.String&gt;&nbsp;terms)</code></th>
<td class="colLast">
<div class="block">Updates the analysis with sightings of the given terms for the current document.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>TfIdfAnalyzer</h4>
<pre>public&nbsp;TfIdfAnalyzer()</pre>
<div class="block">Standard-constructor that will initialize the first document's number to be 1 beside necessary initialization.</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="nextDocument()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nextDocument</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;nextDocument()</pre>
<div class="block">Has to be called to signal to the TfidfAnalyzer that the document switched to a new one.</div>
</li>
</ul>
<a id="updateForTerm(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>updateForTerm</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;updateForTerm&#8203;(java.lang.String&nbsp;term)</pre>
<div class="block">Updates the analysis with a sighting of the given term for the current document.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>term</code> - the term</dd>
</dl>
</li>
</ul>
<a id="updateForTerms(java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>updateForTerms</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;updateForTerms&#8203;(java.util.List&lt;java.lang.String&gt;&nbsp;terms)</pre>
<div class="block">Updates the analysis with sightings of the given terms for the current document.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>terms</code> - the terms</dd>
</dl>
</li>
</ul>
<a id="updateForTerms(java.lang.String[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>updateForTerms</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;updateForTerms&#8203;(java.lang.String[]&nbsp;terms)</pre>
<div class="block">Updates the analysis with sightings of the given terms for the current document.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>terms</code> - the terms</dd>
</dl>
</li>
</ul>
<a id="getNumberOfoccurrencesOfTermInDocument(java.lang.String,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNumberOfoccurrencesOfTermInDocument</h4>
<pre class="methodSignature">public&nbsp;int&nbsp;getNumberOfoccurrencesOfTermInDocument&#8203;(java.lang.String&nbsp;term,
                                                  int&nbsp;docNumber)</pre>
<div class="block">Returns the number of occurrences of a given term in a given document as known by this analysis meaning it
 is not useful before the analysis has been done.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>term</code> - the term in question</dd>
<dd><code>docNumber</code> - the document number in question</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the number of occurrences of term in the document with the given number</dd>
</dl>
</li>
</ul>
<a id="getTfIdfAsMap()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTfIdfAsMap</h4>
<pre class="methodSignature">public&nbsp;java.util.Map&lt;java.lang.String,&#8203;java.util.Map&lt;java.lang.Integer,&#8203;java.lang.Double&gt;&gt;&nbsp;getTfIdfAsMap()</pre>
<div class="block">Returns information about tfidf in the form of a map. The keys are the terms for which a tf-idf is calculated;
 the value is again a map which maps the document-number as key to the value representing the if-idf of the term
 for this specific document.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>tfidf-information</dd>
</dl>
</li>
</ul>
<a id="tfIdfsForDocument(int,java.lang.String[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>tfIdfsForDocument</h4>
<pre class="methodSignature">public&nbsp;java.util.Map&lt;java.lang.String,&#8203;java.lang.Double&gt;&nbsp;tfIdfsForDocument&#8203;(int&nbsp;documentNumber,
                                                                                java.lang.String[]&nbsp;tokens)</pre>
<div class="block">Calculates tf-idfs for tokens in a document with the specified document number. It will do so ONLY for the tokens
 specified in the given array to critically boost runtime in comparison with a brute force approach.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>documentNumber</code> - number of the document in question</dd>
<dd><code>tokens</code> - list of tokens for which the tf-idf should be calculated with respect to the specified document</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the tf-idfs as values for the keys in a map that represent the terms in question</dd>
</dl>
</li>
</ul>
<a id="tfIdfsForDocument(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>tfIdfsForDocument</h4>
<pre class="methodSignature">public&nbsp;java.util.Map&lt;java.lang.String,&#8203;java.lang.Double&gt;&nbsp;tfIdfsForDocument&#8203;(int&nbsp;docNumber)</pre>
<div class="block">Calculates tf-idfs for tokens in a document with the specified document number.
 This method can be very time consuming (linear in number of terms) for huge number of terms
 known by this Analyzer-instance; whenever possible use <a href="#tfIdfsForDocument(int,java.lang.String%5B%5D)"><code>tfIdfsForDocument(int, String[])</code></a> instead!</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>docNumber</code> - number of the document in question</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the tf-idfs as values for the keys in a map that represent the terms in question</dd>
</dl>
</li>
</ul>
<a id="finish()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>finish</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;finish()</pre>
<div class="block">Should be called if all relevant terms for the analysis have been added.
 i.e. one of the classes <a href="#updateForTerm(java.lang.String)"><code>updateForTerm(String)</code></a> or <a href="#updateForTerms(java.lang.String%5B%5D)"><code>updateForTerms(String[])</code></a> methods
 has been called for all relevant terms.</div>
</li>
</ul>
<a id="tf(java.lang.String,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>tf</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;tf&#8203;(java.lang.String&nbsp;term,
                 int&nbsp;docNumber)</pre>
<div class="block">Returns the term-frequency for a given term and document. Remark that there exist several weighting-versions to do this.
 This method calculates: (number of sightings of the specified term in the specified document / total number of terms in this document).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>term</code> - the term in question</dd>
<dd><code>docNumber</code> - the docNumber of the document in question; the user of this class is responsible to establish a proper mapping from docNumbers to actual documents</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the th-value</dd>
</dl>
</li>
</ul>
<a id="idf(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>idf</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;idf&#8203;(java.lang.String&nbsp;term)</pre>
<div class="block">Returns the inverse document frequency for a given term as calculated through:
 log_10(total number of documents/ number od documents containing this term).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>term</code> - the term in question</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the idf-value</dd>
</dl>
</li>
</ul>
<a id="tfidf(java.lang.String,int)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>tfidf</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;tfidf&#8203;(java.lang.String&nbsp;term,
                    int&nbsp;docNumber)</pre>
<div class="block">Returns the tf-idf-value of a given term for a given document.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>term</code> - the term in question</dd>
<dd><code>docNumber</code> - the docNumber specifying the document in question</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the tf-idf value calculatet as product of tf and idf.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
